/*
    (C) 1995-96 AROS - The Amiga Research OS
    $Id: findarg.c,v 1.1.1.1 2005/03/15 15:54:40 laire Exp $

    Desc:
    Lang: english
*/
#include <proto/utility.h>
#include "dos_intern.h"

#define DEBUG_FINDARG(x)		;

#define USE_BLOCKEXTENSION	1

/*****************************************************************************

    NAME */
#include <proto/dos.h>

	AROS_LH2(LONG, FindArg,

/*  SYNOPSIS */
	AROS_LHA(STRPTR, template, D1),
	AROS_LHA(STRPTR, keyword,  D2),

/*  LOCATION */
	struct DosLibrary *, DOSBase, 134, Dos)

/*  FUNCTION

    INPUTS

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY
	29-10-95    digulla automatically created from
			    dos_lib.fd and clib/dos_protos.h

*****************************************************************************/
{
    AROS_LIBFUNC_INIT
    AROS_LIBBASE_EXT_DECL(struct DosLibrary *,DOSBase)

    LONG count = 0;
    STRPTR key;

    DEBUG_FINDARG(dprintf("FindArg: template \"%s\" keyword \"%s\"\n", template, keyword));

    /* Loop over template */
    for (;;)
    {
	UBYTE ck, ct;

	/* Compare key to template */
	key = keyword;
	for (;;)
	{
	    ck = *key;
	    ct = *template;

	    /* If the keyword has ended check the template */
	    if (!ck)
	    {
#if USE_BLOCKEXTENSION
		if (!ct || ct == '=' || ct == '/' || ct == ',' || ct == '[')
#else
		if (!ct || ct == '=' || ct == '/' || ct == ',')
#endif
		{
		    /* The template has ended, too. Return count. */
		    DEBUG_FINDARG(dprintf("FindArg: return %ld\n", count));
		    return count;
		}
		/* The template isn't finished. Stop comparison. */
		break;
	    }
	    /* If the two differ stop comparison. */
	    if (ToLower(ck) != ToLower(ct))
		break;
	    /* Go to next character */
	    key++;
	    template++;
	}
	/* Find next keyword in template */
	for (;;)
	{
	    ct = *template;

	    if (!ct)
	    {
		DEBUG_FINDARG(dprintf("FindArg: template ended, return -1\n"));
		return -1;
	    }
#if USE_BLOCKEXTENSION
	    if (ct == '[')
	    {
		int quotemode = 0;

		++template;
		while ((ct = *template++))
		{
		    if (quotemode && ct == '*')
		    {
			ct = *template++;
			if (!ct)
			    break;

			continue;
		    }

		    if (ct == '\"')
		    {
			quotemode ^= 1;
			continue;
		    }

		    if (!quotemode && ct == ']')
			break;
		}

		/* sanity */
		if (ct != ']')
		{
		    DEBUG_FINDARG(dprintf("FindArg: Invalid [] block, return -1\n"));
		    return -1;
		}

		continue;
	    }
#endif
	    if (ct == '=')
	    {
		/* Alias found */
		template++;
		break;
	    }
	    if (ct == ',')
	    {
		/* Next item found */
		template++;
		count++;
		break;
	    }
	    template++;
	}
    }
    AROS_LIBFUNC_EXIT
} /* FindArg */
